VTK: vtkParametricEnneper Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkParametricEnneper Class Reference

Generate Enneper's surface. More...

`#include <vtkParametricEnneper.h>`

Inheritance diagram for vtkParametricEnneper:
[legend]
Collaboration diagram for vtkParametricEnneper:
[legend]

## Public Types
typedef vtkParametricFunction | Superclass
Public Types inherited from vtkParametricFunction
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkParametricEnneper * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetDimension () override
| Return the parametric dimension of the class. More...
void | Evaluate (double uvw[3], double Pt[3], double Duvw[9]) override
| Enneper's surface. More...
double | EvaluateScalar (double uvw[3], double Pt[3], double Duvw[9]) override
| Calculate a user defined scalar using one or all of uvw, Pt, Duvw. More...
Public Member Functions inherited from vtkParametricFunction
vtkParametricFunction * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | SetMinimumU (double)
| Set/Get the minimum u-value. More...
virtual double | GetMinimumU ()
| Set/Get the minimum u-value. More...
virtual void | SetMaximumU (double)
| Set/Get the maximum u-value. More...
virtual double | GetMaximumU ()
| Set/Get the maximum u-value. More...
virtual void | SetMinimumV (double)
| Set/Get the minimum v-value. More...
virtual double | GetMinimumV ()
| Set/Get the minimum v-value. More...
virtual void | SetMaximumV (double)
| Set/Get the maximum v-value. More...
virtual double | GetMaximumV ()
| Set/Get the maximum v-value. More...
virtual void | SetMinimumW (double)
| Set/Get the minimum w-value. More...
virtual double | GetMinimumW ()
| Set/Get the minimum w-value. More...
virtual void | SetMaximumW (double)
| Set/Get the maximum w-value. More...
virtual double | GetMaximumW ()
| Set/Get the maximum w-value. More...
virtual void | SetJoinU (vtkTypeBool)
| Set/Get the flag which joins the first triangle strip to the last one. More...
virtual vtkTypeBool | GetJoinU ()
| Set/Get the flag which joins the first triangle strip to the last one. More...
virtual void | JoinUOn ()
| Set/Get the flag which joins the first triangle strip to the last one. More...
virtual void | JoinUOff ()
| Set/Get the flag which joins the first triangle strip to the last one. More...
virtual void | SetJoinV (vtkTypeBool)
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual vtkTypeBool | GetJoinV ()
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual void | JoinVOn ()
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual void | JoinVOff ()
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual void | SetJoinW (vtkTypeBool)
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual vtkTypeBool | GetJoinW ()
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual void | JoinWOn ()
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual void | JoinWOff ()
| Set/Get the flag which joins the ends of the triangle strips. More...
virtual void | SetTwistU (vtkTypeBool)
| Set/Get the flag which joins the first triangle strip to the last one with a twist. More...
virtual vtkTypeBool | GetTwistU ()
| Set/Get the flag which joins the first triangle strip to the last one with a twist. More...
virtual void | TwistUOn ()
| Set/Get the flag which joins the first triangle strip to the last one with a twist. More...
virtual void | TwistUOff ()
| Set/Get the flag which joins the first triangle strip to the last one with a twist. More...
virtual void | SetTwistV (vtkTypeBool)
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual vtkTypeBool | GetTwistV ()
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual void | TwistVOn ()
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual void | TwistVOff ()
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual void | SetTwistW (vtkTypeBool)
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual vtkTypeBool | GetTwistW ()
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual void | TwistWOn ()
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual void | TwistWOff ()
| Set/Get the flag which joins the ends of the triangle strips with a twist. More...
virtual void | SetClockwiseOrdering (vtkTypeBool)
| Set/Get the flag which determines the ordering of the vertices forming the triangle strips. More...
virtual vtkTypeBool | GetClockwiseOrdering ()
| Set/Get the flag which determines the ordering of the vertices forming the triangle strips. More...
virtual void | ClockwiseOrderingOn ()
| Set/Get the flag which determines the ordering of the vertices forming the triangle strips. More...
virtual void | ClockwiseOrderingOff ()
| Set/Get the flag which determines the ordering of the vertices forming the triangle strips. More...
virtual void | SetDerivativesAvailable (vtkTypeBool)
| Set/Get the flag which determines whether derivatives are available from the parametric function (i.e., whether the Evaluate() method returns valid derivatives). More...
virtual vtkTypeBool | GetDerivativesAvailable ()
| Set/Get the flag which determines whether derivatives are available from the parametric function (i.e., whether the Evaluate() method returns valid derivatives). More...
virtual void | DerivativesAvailableOn ()
| Set/Get the flag which determines whether derivatives are available from the parametric function (i.e., whether the Evaluate() method returns valid derivatives). More...
virtual void | DerivativesAvailableOff ()
| Set/Get the flag which determines whether derivatives are available from the parametric function (i.e., whether the Evaluate() method returns valid derivatives). More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkParametricEnneper * | SafeDownCast (vtkObjectBase *o)
static vtkParametricEnneper * | New ()
| Construct Enneper's surface with the following parameters: MinimumU = -2, MaximumU = 2, MinimumV = -2, MaximumV = 2, JoinU = 0, JoinV = 0, TwistU = 0, TwistV = 0, ClockwiseOrdering = 0, DerivativesAvailable = 1. More...
Static Public Member Functions inherited from vtkParametricFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkParametricFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkParametricEnneper ()
| ~vtkParametricEnneper () override
Protected Member Functions inherited from vtkParametricFunction
| vtkParametricFunction ()
| ~vtkParametricFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkParametricFunction
double | MinimumU
double | MaximumU
double | MinimumV
double | MaximumV
double | MinimumW
double | MaximumW
vtkTypeBool | JoinU
vtkTypeBool | JoinV
vtkTypeBool | JoinW
vtkTypeBool | TwistU
vtkTypeBool | TwistV
vtkTypeBool | TwistW
vtkTypeBool | ClockwiseOrdering
vtkTypeBool | DerivativesAvailable
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Generate Enneper's surface.

vtkParametricEnneper generates Enneper's surface. Enneper's surface is a self-intersecting minimal surface possessing constant negative Gaussian curvature

For further information about this surface, please consult the technical description "Parametric surfaces" in http://www.vtk.org/publications in the "VTK Technical Documents" section in the VTk.org web pages.

Thanks:
  Andrew Maclean andre.nosp@m.w.am.nosp@m.aclea.nosp@m.n@gm.nosp@m.ail.c.nosp@m.om for creating and contributing the class.

Online Examples:

Tests:
  vtkParametricEnneper (Tests)

Definition at line 40 of file vtkParametricEnneper.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkParametricFunction vtkParametricEnneper::Superclass

Definition at line 43 of file vtkParametricEnneper.h.

## Constructor & Destructor Documentation

## ◆ vtkParametricEnneper()

vtkParametricEnneper::vtkParametricEnneper | ( |  | ) |
| protected

## ◆ ~vtkParametricEnneper()

vtkParametricEnneper::~vtkParametricEnneper | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkParametricEnneper::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkParametricEnneper::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkParametricFunction.

## ◆ SafeDownCast()

static vtkParametricEnneper* vtkParametricEnneper::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkParametricEnneper::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkParametricFunction.

## ◆ NewInstance()

vtkParametricEnneper* vtkParametricEnneper::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkParametricEnneper::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ New()

static vtkParametricEnneper* vtkParametricEnneper::New | ( |  | ) |
| static

Construct Enneper's surface with the following parameters: MinimumU = -2, MaximumU = 2, MinimumV = -2, MaximumV = 2, JoinU = 0, JoinV = 0, TwistU = 0, TwistV = 0, ClockwiseOrdering = 0, DerivativesAvailable = 1.

## ◆ GetDimension()

int vtkParametricEnneper::GetDimension | ( |  | ) |
| inlineoverridevirtual

Return the parametric dimension of the class.

Implements vtkParametricFunction.

Definition at line 60 of file vtkParametricEnneper.h.

## ◆ Evaluate()

void vtkParametricEnneper::Evaluate | ( | double | uvw[3],
|  | double | Pt[3],
|  | double | Duvw[9]
| ) |  |
| overridevirtual

Enneper's surface.

This function performs the mapping \(f(u,v) \rightarrow (x,y,x)\), returning it as Pt. It also returns the partial derivatives Du and Dv. \(Pt = (x, y, z), Du = (dx/du, dy/du, dz/du), Dv = (dx/dv, dy/dv, dz/dv)\) . Then the normal is \(N = Du X Dv\) .

Implements vtkParametricFunction.

## ◆ EvaluateScalar()

double vtkParametricEnneper::EvaluateScalar | ( | double | uvw[3],
|  | double | Pt[3],
|  | double | Duvw[9]
| ) |  |
| overridevirtual

Calculate a user defined scalar using one or all of uvw, Pt, Duvw.

uv are the parameters with Pt being the cartesian point, Duvw are the derivatives of this point with respect to u, v and w. Pt, Duvw are obtained from Evaluate().

This function is only called if the ScalarMode has the value vtkParametricFunctionSource::SCALAR_FUNCTION_DEFINED

If the user does not need to calculate a scalar, then the instantiated function should return zero.

Implements vtkParametricFunction.

The documentation for this class was generated from the following file:

- Common/ComputationalGeometry/vtkParametricEnneper.h